-- adder_4bit.vhd
library IEEE;
use IEEE.std_logic_1164.all;

-- 入出力の宣言
entity adder_4bit is
	port(
	
		AIN	: in std_logic_vector(3 downto 0);
		BIN	: in std_logic_vector(3 downto 0);
		SUM	: out std_logic_vector(4 downto 0)
	);
end adder_4bit;

-- 回路の記述
architecture RTL of adder_4bit is
-- コンポーネント half_adder の宣言
component half_adder
	port(
		A	: in std_logic;
		B	: in std_logic;
		S	: out std_logic;
		CO	: out std_logic
	);
end component;

-- コンポーネント full_adder の宣言
component full_adder
	port(
		A	: in std_logic;
		B	: in std_logic;
		CI	: in std_logic;
		S	: out std_logic;
		CO	: out std_logic
	);
end component;
-- 内部信号の定義
signal CO_TMP0 : std_logic;
signal CO_TMP1 : std_logic;
signal CO_TMP2 : std_logic;

begin
-- コンポーネント half_adder の実体化と入出力の相互接続
	C1 : half_adder
		port map(
			A  => AIN(0),
			B  => BIN(0),
			S  => SUM(0),
			CO => CO_TMP0
		);
-- コンポーネント full_adder(1) の実体化と入出力の相互接続
	C2 : full_adder
		port map(
			A  => AIN(1),
			B  => BIN(1),
			CI => CO_TMP0,
			S  => SUM(1),
			CO => CO_TMP1
		);
-- コンポーネント full_adder(2) の実体化と入出力の相互接続
	C3 : full_adder
		port map(
			A  => AIN(2),
			B  => BIN(2),
			CI => CO_TMP1,
			S  => SUM(2),
			CO => CO_TMP2
		);
-- コンポーネント full_adder(3) の実体化と入出力の相互接続
	C4 : full_adder
		port map(
			A  => AIN(3),
			B  => BIN(3),
			CI => CO_TMP2,
			S  => SUM(3),
			CO => SUM(4)
		);

end RTL;

