-- full_adder.vhd
library IEEE;
use IEEE.std_logic_1164.all;

-- 入出力の宣言
entity full_adder is
	port(
		A	: in std_logic;
		B	: in std_logic;
		CI	: in std_logic;
		S	: out std_logic;
		CO	: out std_logic
	);
end full_adder;
-- 回路の記述
architecture RTL of full_adder is
-- コンポーネント half_adder の宣言
component half_adder
	port(
		A	: in std_logic;
		B	: in std_logic;
		S	: out std_logic;
		CO	: out std_logic
	);
end component;
-- 内部信号の定義
signal S_TMP	: std_logic;
signal CO_TMP1	: std_logic;
signal CO_TMP2	: std_logic;

begin
-- コンポーネント half_adder の実体化と入出力の相互接続
	C1 : half_adder
		port map(
			A => A,
			B => B,
			S => S_TMP,
			CO => CO_TMP1
		);
-- コンポーネント full_adder の実体化と入出力の相互接続
	C2 : half_adder
		port map(
			A => S_TMP,
			B => CI,
			S => S,
			CO => CO_TMP2
		);

	CO <= CO_TMP1 or CO_TMP2;
end RTL;