-- count_16.vhd（呼び出し側）
library IEEE;
use IEEE.std_logic_1164.all;

-- 入出力の宣言
entity count_16 is
	port(
			CLK		: in std_logic;
			RST		: in std_logic;
			COUNT_16	: out std_logic_vector(15 downto 0)
	);
end count_16;

-- 回路の記述
architecture RTL of count_16 is

-- コンポーネント count_nbit の宣言
component count_nbit
	generic(
			N_BIT : integer := 8
	);
	port(
			CLK		: in std_logic;
			RST		: in std_logic;
			COUNT_N	: out std_logic_vector(N_BIT - 1 downto 0)
	);
end component;

begin
-- コンポーネント count_nbit の実体化と入出力の相互接続
	C1 : count_nbit
		generic map(N_BIT => 16)
		port map(
			CLK => CLK,
			RST => RST,
			COUNT_N => COUNT_16
		);		
end RTL;
