-- fetch_rom_timequest.vhd   ROMメモリブロックのタイミング・シミュレーション
library IEEE;
use IEEE.std_logic_1164.all;
use IEEE.std_logic_unsigned.all;

-- 入出力の宣言
entity fetch_rom_timequest is
	port (
		ADDR	: IN std_logic_vector (7 DOWNTO 0);
		CLK	: IN std_logic;
		Q2		: OUT std_logic_vector (14 DOWNTO 0)
	);
end fetch_rom_timequest;

-- 回路の記述
architecture RTL of fetch_rom_timequest is

-- コンポーネント fetch_rom　の宣言
component fetch_rom
	port (
		address	: IN std_logic_vector (7 DOWNTO 0);
		clock		: IN std_logic;
		q			: OUT std_logic_vector (14 DOWNTO 0)
	);
end component;

-- 内部信号の定義
signal Q		: std_logic_vector(14 downto 0);

begin
-- コンポーネント fetch_rom　の実体化と入出力の相互接続
	C1: fetch_rom port map(
			address => ADDR,
			clock => CLK,
			q => Q
		);

-- 受け側 D-FF の記述
	process(CLK)
	begin
		if(CLK'event and CLK = '1') then
			Q2 <= Q;
		end if;
	end process;

end RTL;
