-- ram_1port_sim.vhd 
library IEEE;
use IEEE.std_logic_1164.all;
use IEEE.std_logic_unsigned.all;

-- 入出力の宣言
entity ram_1port_sim is
end ram_1port_sim;

-- 回路の記述
architecture SIM of ram_1port_sim is
-- コンポーネント ram_1port の宣言
component ram_1port
	port (
		address	: IN STD_LOGIC_VECTOR (5 DOWNTO 0);
		clock		: IN STD_LOGIC;
		data		: IN STD_LOGIC_VECTOR (15 DOWNTO 0);
		wren		: IN STD_LOGIC ;
		q			: OUT STD_LOGIC_VECTOR (15 DOWNTO 0)
	);
end component;
-- 内部信号の定義
signal ADDRESS	: std_logic_vector(5 downto 0);
signal CLK 		: std_logic;
signal DATA		: std_logic_vector(15 downto 0);
signal WREN 	: std_logic;
signal Q			: std_logic_vector(15 downto 0);

begin
-- コンポーネント ram_1port の実体化と入出力の相互接続
	C1: ram_1port port map(
			address => ADDRESS,
			clock => CLK,
			data => DATA,
			wren => WREN,
			q => Q
		);
-- 入力信号 CLK の波形を記述
	process	begin
		CLK <= '0';
		wait for 10 ns;
		CLK <= '1';
		wait for 10 ns;
	end process;
-- 入力信号 ADDRESS の波形を記述
	process begin
		ADDRESS <= "000001";
		wait for 40 ns;
		ADDRESS <= "000011";
		wait for 40 ns;
		ADDRESS <= "000001";
		wait for 40 ns;
	end process;
-- 入力信号 DATA の波形を記述
	process begin
		DATA <= "0000000000000010";
		wait for 40 ns;
		DATA <= "0000000000000100";
		wait for 40 ns;
		DATA <= "0000000000000110";
		wait for 40 ns;
	end process;
-- 入力信号 WREN の波形を記述
	process begin
		WREN <= '0';
		wait for 20 ns;
		WREN <= '1';
		wait for 20 ns;
	end process;

end SIM;
